#include <RaviartThomas.h> 


int RaviartThomas:: nbf() {
  return Ns.size();  
}

void RaviartThomas:: compute_basis_functions() {

  // see e.g. Brezzi and Fortin book page 116 for the definition


  if (p->str() == "ReferenceLine") { 
    //FIXME:: proper error handling
    cout <<"THIS SHOULD NEVER HAPPEND"<<endl;  
  } else if (p->str() == "ReferenceTriangle" ) { 
    ReferenceTriangle& ref_triangle = (ReferenceTriangle&)(*p); 
    ex r = pol(order-1, 2, "a"); 
    lst p = polv(order-1, 2, "b"); 

    lst pspace = lst( p.op(0) + r*x, 
		      p.op(1) + r*y);   
    print(pspace); 

    lst variables_11 = coeffs(pspace.op(0));
    lst variables_12 = coeffs(pspace.op(1));

    print(variables_11); 
    print(variables_12); 

    symbol t("t"); 
    for (int i=1; i<= 3; i++) {
      Line line = ref_triangle.line(i); 
      cout <<"line "<<line.repr(t)<<endl; 
    }

    

  } else if ( p->str() == "ReferenceTetrahera" ) { 
    ex r = pol(order-1, 3, "a"); 
    ex p = polv(order-1, 3, "b"); 

    lst pspace = lst( p.op(0) + r*x, 
		      p.op(1) + r*y, 
		      p.op(2) + r*z);   
    print(pspace); 


  }
}


void RaviartThomas:: set(Polygon& p_) {
  StandardFE:: set(p_); 
}


void RaviartThomas:: set(int order_) { 
  StandardFE:: set(order_); 
}


ex RaviartThomas:: dof(int i) {
  return StandardFE::dof(i);  
}


ex RaviartThomas::N(int i) {  
  return StandardFE::N(i); 
}



