#include <SyFi.h>

int main() {

  // create a triangle
  Triangle t1(lst(0,0), lst(1,0), lst(0,1)); 
  symbol t("t"); 

  for (int j=1; j<= 3; j++) {
    // create the polynomial space
    ex Nj = pol(1,2,istr("a",j)); 
    cout <<"Nj initially " <<Nj<<endl; 
    lst variables = coeffs(Nj); 
    lst equations; 
  
    Line line; 
    ex   dofi; 
     
    for (int i=1; i<= 3; i++) {
      line = t1.line(i);         // pick out the i'th line 
      dofi = line.integrate(Nj); // create the dof which is a line integral 
      ex eq = dofi == dirac(i,j); 
      equations.append(eq); 
    }

    ex subs = lsolve(equations, variables); 
    Nj = Nj.subs(subs); 
    cout <<"Nj with determined coeff "<<Nj<<endl; 
  }
  


}
