#!/bin/env python 

# FIXME: employs local libraries instead of the
# installed ones. It is then necessary
# to add the libary ../syfi/.libs to LD_LIBRARY_PATH

import os
from distutils.core import setup, Extension
name = 'SyFi' 
swig_cmd ='swig -python -c++ -I../syfi SyFi.i'
os.system(swig_cmd)
sources = ['SyFi_wrap.cxx'] 
setup(name = 'SyFi', 
      ext_modules = [Extension('_' + 'SyFi', sources, 
                     include_dirs=['-I.', '../syfi'],   
		     libraries=['syfi', 'ginac'], 
		     library_dirs=['/usr/local/lib', '../syfi/.lib'])]) 
	
