
void stokes() {
  std::map<std::pair<int,int>,double> A;
  std::map<std::pair<int,int>,double> B;
  std::map<std::pair<int,int>,double> C;
  std::map<int, double> b; 
  std::pair<int,int> index;

  FiniteElement vfe;
  FiniteElement pfe;

  Triangle triangle; Mesh mesh;  
  int ig, jg; 
  int t=0; 
  for ( triangle = mesh.iter.begin(); triangle != mesh.iter.end(); triangle++) { 
    t++; 
    vfe.set(triange); 
    pfe.compute_basis_functions(); 

    //upper left block vfe*vfe 
    for (int i=1; i <= vfe.nbf; i++) {  
      ig = vdofs.glob_dof(t, i , vfe.dof(i)); 
      index.first = ig; 
      for (int j=1; j <= vfe.nbf; j++) {  
        jg = vdofs.glob_dof(t, j, vfe.dof(j)); 
	index.second = jg; 
	A[index] += integral(triangle,grad(vfe.N(i)*grad(vfe.N(j)))); 
      }
      b[ig] += integral(triangle,f*vfe.N(i));  
    }

    //upper left right vfe*pfe 
    for (int i=1; i <= vfe.nbf; i++) {  
      ig = vdofs.glob_dof(t, i, vfe.dof(i)); 
      index.first = ig; 
      for (int j=1; j <= vfe.nbf; j++) {  
        jg = pdofs.glob_dof(t, i,  pfe.dof(j)); 
	index.second = jg; 
	B[index] += integral(triangle,vfe.N(i)*grad(pfe.N(j))); 
      }

    //lower left right vfe*pfe 
    for (int i=1; i <= pfe.nbf; i++) {  
      ig = pdofs.glob_dof(t, i, pfe.dof(i)); 
      index.first = ig; 
      for (int j=1; j <= vfe.nbf; j++) {  
        jg = vdofs.glob_dof(t, j, vfe.dof(j)); 
	index.second = jg; 
	C[index] += integral(triangle, div(vfe.N(i))*pfe.N(j)); 
      }


  }



