#include <SyFi.h>

int main() {
  int order = 2; 
  int nsd   = 2; 

  ex p = pol(order,nsd, "a"); 
  cout <<"polynom p = "<<p<<endl; 
  EQUAL_OR_DIE(p,"y^2*a5+x^2*a3+a2*y+y*x*a4+a0+a1*x"); 

  ex dpdx = diff(p,x);   
  cout <<"dpdx = "<<dpdx<<endl; 
  EQUAL_OR_DIE(dpdx, "y*a4+a1+2*x*a3"); 

  Triangle triangle(lst(0,0), lst(1,0), lst(0,1)); 
  ex intp = triangle.integrate(p); 
  cout <<"integral of p over reference triangle = "<<intp<<endl;  
  EQUAL_OR_DIE(intp, "1/6*a2+1/6*a1+1/12*a5+1/2*a0+1/24*a4+1/12*a3"); 
 

}
