#include <RaviartThomas.h>





void compute_RaviartThomas_element(Polygon& p, int order) { 
  std::map<std::pair<int,int>, ex> A;
  std::map<std::pair<int,int>, double> Aval;
  std::pair<int,int> index;
  RaviartThomas fe; 
  fe.set(order); 
  fe.set(p); 
  fe.compute_basis_functions(); 
  for (int i=1; i<= fe.nbf() ; i++) {
    cout <<"fe.N("<<i<<")="<<fe.N(i)<<endl; 
  }
}



void check_RaviartThomas() {


  cout <<"2D ----------------------------"<<endl; 
  ReferenceTriangle triangle("t"); 
  compute_RaviartThomas_element(triangle, 1); 


  cout <<"3D ----------------------------"<<endl; 
  ReferenceTetrahedron tetrahedron("t"); 
  compute_RaviartThomas_element(tetrahedron, 1); 
  
}


int main() {
  check_RaviartThomas(); 
}



